Subject: RE: [PATCHv2 net-next 3/5] sctp: add SCTP_EXPOSE_POTENTIALLY_FAILED_STATE sockopt

From: David Laight <[email-masked]>
Date: Mon, 14 Oct 2019 08:49:54 +0000

From: Xin Long <[email-masked]>
> Sent: 14 October 2019 09:37
...
> RFC actually keeps adding new notifications,

That RFC keeps moving the goalposts.
Even the structures are guaranteed to have holes.

> and a user shouldn't expect
> the specific notifications coming in some exact orders. They should just
> ignore it and wait until the ones they expect. I don't think some users
> would abort its application when getting an unexpected notification.

I've an example of exactly 1 application.
It uses TCP-style sockets (and will work over TCP).
It does getsockopt(SCTP_EVENTS), sets sctp_association_event, then setsockopt().
Any MSG_NOTIFICATION is assumed to be the a connection reset (enabled above)
and treated as an inwards disconnect.

So any unexpected notification will kill the connection.

I suspect it isn't the only one..

	David

-
Registered Address Lakeside, Bramley Road, Mount Farm, Milton Keynes, MK1 1PT, UK
Registration No: 1397386 (Wales)